/* eslint-disable @typescript-eslint/no-empty-interface */
// Generated code for namespace: org.accordproject.templatemark

// imports
import {IChild,INode} from './org.accordproject.commonmark';

// interfaces
export interface IElementDefinition extends IChild {
   name: string;
   elementType?: string;
}

export interface IVariableDefinition extends IElementDefinition {
   identifiedBy?: string;
}

export interface IFormattedVariableDefinition extends IVariableDefinition {
   format: string;
}

export interface IEnumVariableDefinition extends IVariableDefinition {
   enumValues: string[];
}

export interface IFormulaDefinition extends IElementDefinition {
   dependencies?: string[];
   code: string;
}

export interface IBlockDefinition extends IElementDefinition {
}

export interface IClauseDefinition extends IBlockDefinition {
}

export interface IContractDefinition extends IBlockDefinition {
}

export interface IWithDefinition extends IBlockDefinition {
}

export interface IConditionalDefinition extends IBlockDefinition {
   whenTrue: IChild[];
   whenFalse: IChild[];
}

export interface IOptionalDefinition extends IBlockDefinition {
   whenSome: IChild[];
   whenNone: IChild[];
}

export interface IListBlockDefinition extends IBlockDefinition {
   type: string;
   tight: string;
   start?: string;
   delimiter?: string;
}

export interface IJoinDefinition extends IBlockDefinition {
   separator: string;
}

